//      Restrict the available memory in a bash-shell by
//      ulimit -m 1024
//                                   see also  ulimit -a
//      g++ -Wall -Weffc++ main.cpp myvector.cpp myexceptions.cpp provocate.cpp

#include <iostream>
#include <cstdlib>            // system,  atoll
#include <cstdio>             // sprintf
#include "myvector.h"
#include "numvector.h"
#include "myexceptions.h"
#include "provocate.h"
#include "mymatrix.h"

using namespace std;


int main(const int argc, const char* argv[])
{
    long long int n;
    long long int i;

//			Neuen New-Handler setzen
//set_new_handler( my_new_handler );
    cout << "Code: " << argv[0] << endl;
    if (argc>1)
        n = atoll(argv[1]);           //  first command line argument
    else
    {
        cout << " n = ";
        cin >> n;
//        n = 2ll<<34;
    }

    try
    {
        MyVector AA(n);			// geht nicht. Cast notwendig
//MySaveVector AA(n);
    }
    catch (bad_alloc)
    {
        cout << "Jetzt hab ich Dich ################" << endl;
    }
    catch (...)
    {
        cout << "noch einer" << endl;
    }
    cout << "------------"<< n <<"-----------------------------\n";
    MyVector aa(n);			// geht nicht. Cast notwendig
    for (i=0; i<n; i++)
    {
        aa[i] = (i+1)*3.14;
    }
//cout << aa << endl;
    cout << "##############" << aa.size()<< "###################\n";
    try
    {

        aa[3] = 4.5;
        cout << aa[3] << endl;

        const MyVector bb( aa );

// 	cout << bb[13] << endl;
        Provocate(bb,13);
    }
    catch (bad_alloc)
    {
        cout << "##########  Hey bad allocation ################" << endl;
    }
    catch (OutOfRange &err)
    {
        cerr << endl << "---------------------------------------------------\n";
        cerr << "Indexerror: " << err.Index() << "   " << err.Interval_End() << endl;
        cerr << __FILE__ << ":line " << __LINE__ << "   from " << __DATE__ << "  " << __TIME__<<endl;
//   system("echo ""Du hast Mist gebaut."" | mail -s ""Indexerror"" gundolf.haase@uni-graz.at");

//		Provide more information
        string serr(__FILE__);
        serr += ":line ";
        char tmp[10];
        sprintf(tmp, "%d", __LINE__);
        serr += tmp;
        serr += "   from  ";
        serr += __DATE__;
        serr += "  ";
        serr += __TIME__;
        serr += ".";
//   cerr << serr << endl;
        string serr2 = string("echo ") + serr +  " | mail -s \"Indexerror\" gundolf.haase@uni-graz.at";
        cout << serr2 << endl;
        cout.flush();
//        int ecode = system(serr2.c_str());     // system call: requires sendmail
//        if (ecode!=0)
//        {
//            cerr << "Error in system call\n";
//        }
        cerr << "---------------------------------------------------\n";
    }
    catch (...)
    {
        cerr << "Alle restlichen Exceptions" << endl;
    }

    // ########################################################################
    cout << "\n####################   EXT   #####################\n";
    MyVector cc {6.7, 2.3, -1.1, 0.1, 1e-13};
    cout << cc <<endl;

    cout << "\n####################   NumVector +  #####################\n";
    NumVector dd {-124, 6.7, 2.3, -1.1, 0.1, 1e-13};
    cout << dd <<endl;

    const NumVector ee(dd);
    cout << ee <<endl;

    dd += ee;
    cout << dd <<endl;

    NumVector ff;
    ff = dd+(ee+dd+(dd+ee)+ee);
    cout << ff <<endl;

    cout << "\n####################   NumVector *  #####################\n";
    cout << innerProd(dd,ee);
    ff = 3.0*(dd*5.0);
    cout << ff <<endl;



    // ########################################################################

    cout << "\n####################   Matrix   #####################\n";
    MyMatrix mm(3,4);

    mm[2][3] = -1.234;
    cout << mm[2][3] << endl;
    cout << mm[2][3] << endl;


    return 0;
}


